package de.unikoblenz.fgbks.core.dmn.domain.vdmn;

import de.unikoblenz.fgbks.base.utils.boundary.Boundary;
import de.unikoblenz.fgbks.core.dmn.domain.ids.InputEntryId;
import org.camunda.bpm.model.dmn.instance.InputEntry;

/**
 * This interface represents a single input value (or cell) in a {@link VDmnDecisionTable}. This is
 * a {@link VDmnValue}.
 */
public interface VDmnInputValue extends VDmnValue {

  /**
   * Get the original Input Entry.
   *
   * @return the {@link InputEntry
   */
  InputEntry getInputEntry();

  /**
   * Get the {@link Boundary} instance of the value.
   *
   * @return the {@link Boundary} instance of the value
   */
  Boundary getBoundary();

  /**
   * Get the {@link InputEntryId}.
   *
   * @return the {@link InputEntryId}
   */
  default InputEntryId getInputEntryId() {
    return (InputEntryId) getId();
  }

  /**
   * Get the {@link VDmnInputColumn}.
   *
   * @return the {@link VDmnInputColumn}
   */
  default VDmnInputColumn getVDmnInputColumn() {
    return (VDmnInputColumn) getVDmnColumn();
  }
}
